﻿using Newtonsoft.Json;
using Price2SpyAPI;

public class TestClient
{
	private static String API_KEY = "YOUR_API_KEY_HERE";
	/* Add https://api.price2spy.com/soap?wsdl to your project as Service Reference */
	private static p2sapi CLIENT;


	static async Task Main(String[] args)
	{
		CLIENT = new p2sapiClient();
		List<brandType> brands = await getBrands(API_KEY);
		foreach (brandType brand in brands) 
		{ 
			List<productWithUrlsType> products = await getCurrentPricingData(brand.id, API_KEY);
			Console.WriteLine("Brand: " + brand.name);
			Console.WriteLine("-------------------");
			Console.WriteLine(JsonConvert.SerializeObject(products));
			Console.WriteLine("-------------------");
		} 

		long productId = 123456789; // Example product ID, it should be replaced with actual product ID.
		string url = "https://www.luluhypermarket.com/en-ae/glow-lovely-face-cream-advanced-multi-vitamin-vita/p/1880353";

		String productName = "New product name"; // Example product name, it should be replaced with actual product name.
		decimal purchuasePrice = 30; //Example purchuase price, it should be replaced with actual purchuase price.
		await updateProduct(productId, productName, purchuasePrice, API_KEY); 
		
		long urlId = await insertUrl(productId, url, API_KEY);
	}
	static async Task<List<brandType>> getBrands(String API_KEY)
	{
		getBrandsRequestType getBrandsRequestType = new getBrandsRequestType();
		getBrandsRequestType.apiKey = API_KEY;
		getBrands inValue = new getBrands();
		inValue.getBrandsRequest = getBrandsRequestType;
		getBrandsResponse getBrandsResponse = await CLIENT.getBrandsAsync(inValue);

		List<brandType> brands = getBrandsResponse.getBrandsResponse1.ToList();
		return brands;
	}

	static async Task<List<productWithUrlsType>> getCurrentPricingData(int brandId, String API_KEY)
	{
		searchProductsType search = new searchProductsType();
		search.brandId = brandId;

		getCurrentPricingDataRequestType getCurrentPricingDataRequestType = new getCurrentPricingDataRequestType();
		getCurrentPricingDataRequestType.apiKey = API_KEY;
		getCurrentPricingDataRequestType.search = search;
		getCurrentPricingData inValue = new getCurrentPricingData();
		inValue.getCurrentPricingDataRequest = getCurrentPricingDataRequestType;
		getCurrentPricingDataResponse response = await CLIENT.getCurrentPricingDataAsync(inValue);

		List<productWithUrlsType> products = response.getCurrentPricingDataResponse1.products.ToList();
		return products; 
	}

	static async Task updateProduct(long productId, String productName, decimal purchuasePrice, String API_KEY)
    {
		updateProductType updateProductType = new updateProductType();
		updateProductType.productId = productId;
		updateProductType.productName = productName;
		updateProductType.purchasePrice = purchuasePrice;

		updateProductRequestType updateProductRequestType = new updateProductRequestType();
		updateProductRequestType.apiKey = API_KEY;
		updateProductRequestType.update = updateProductType;
		
		updateProduct inValue = new updateProduct();
		inValue.updateProductRequest = updateProductRequestType;

		await CLIENT.updateProductAsync(inValue);
	}

	static async Task<long> insertUrl(long productId, string url, String API_KEY) 
	{
		insertUrlType insertUrlType = new insertUrlType();
		insertUrlType.productId = productId;
		insertUrlType.url = url;
		insertUrlType.active = true;
		insertUrlType.showInReports = true;

		insertUrlRequestType insertUrlRequestType = new insertUrlRequestType();
		insertUrlRequestType.insert = insertUrlType;
		insertUrlRequestType.apiKey = API_KEY;

		insertUrl inValue = new insertUrl();
		inValue.insertUrlRequest = insertUrlRequestType;

		insertUrlResponse response = await CLIENT.insertUrlAsync(inValue);

		return (long)Convert.ToDouble(response.insertUrlResponse1);
	}

}